package com.docus.soap.api.request.complain;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public enum ComplaintProcessStatus {

    /*受理中*/
    RECEIVED(0),
    /*网友已给出方案*/
    BUYER_GIVE_SOLUTION(1),
    /*商家已给出方案*/
    SELLER_GIVE_SOLUTION(2),
    /*安排监理上门*/
    SUPERVISOR_CALL(3),
    /*双方达成协议*/
    REACH_AGREEMENT(4),
    /*协调未果*/
    CONSULTATION_NO_RESULT(5),
    /*无理投诉*/
    UNJUSTIFIABLE_COMPLAINT(6),
    /*处理完成*/
    FINISH(7),
    /*节后处理*/
    PROCESS_AFTER_HOLIDAY(8);

    private static final Logger LOGGER = LoggerFactory.getLogger(ComplaintProcessStatus.class);

    private int value;

    ComplaintProcessStatus(int value) {
        this.value = value;
    }

    @JsonValue
    public int getValue() {
        return value;
    }

    @JsonCreator
    public static ComplaintProcessStatus fromValue(int code) {
        for (ComplaintProcessStatus status : ComplaintProcessStatus.values()) {
            if (status.value == code) {
                return status;
            }
        }
        LOGGER.warn(ComplaintProcessStatus.class.getName() + " can not find value :" + code);
        return null;
    }

}
