package com.docus.soap.api;

import com.docus.core.util.AssertUtils;
import com.docus.soap.api.request.complain.GetTableByIdDateRequest;
import com.docus.soap.api.response.complain.ComplaintListResult;
import com.docus.soap.api.service.ComplaintAPIService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import javax.inject.Inject;

@RunWith(SpringRunner.class)
@SpringBootTest(classes = DocusSoapApplication.class, webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
public class ComplaintAPIServiceTest {

    private final Logger logger = LoggerFactory.getLogger(ComplaintAPIServiceTest.class);

    @Value("${soap.complaint.api.url}")
    public String soapComplaintUrl;
    @Value("${soap.complaint.api.action}")
    public String soapComplaintAction;

    @Inject
    private ComplaintAPIService complaintAPIService;


    @Test
    public void getTableByIdDateTest() {
        GetTableByIdDateRequest request = new GetTableByIdDateRequest();
        request.setSys("JSScan");
        ComplaintListResult result = complaintAPIService.getTableByIdDate(request, getTableByIdDateSettings());
        AssertUtils.assertNotNull(result, "not null");
    }

    private SoapAPISettings getTableByIdDateSettings() {
        SoapAPISettings soapAPISettings = new SoapAPISettings();
        soapAPISettings.setAction(soapComplaintAction);
        soapAPISettings.setUri(soapComplaintUrl);
        return soapAPISettings;
    }
}
